<?php

/*
 * SlimStat: simple web analytics
 * Copyright (C) 2010 Pieces & Bits Limited
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

require_once( realpath( dirname( dirname( __FILE__ ) ) ).'/_lib/i18n.php' );

class SlimStatI18n extends SlimStatI18nBase {
	var $indeterminable = 'Unbekannt';
	
	var $decimal_point = ',';
	
	var $thousands_separator = '.';
	
	var $language_country = '%s (%s)'; // e.g. 'Deutsch (Deutschland)'
	
	var $titles = array(
		'resource' => 'Seiten',
		'country' => 'Länder',
		'language' => 'Sprachen',
		'browser' => 'Browser',
		'version' => 'Versionen',
		'platform' => 'Betriebssysteme',
		'resolution' => 'Bildschirmauflösung',
		'remote_ip' => 'IP Addressen',
		'search_terms' => 'Suchwörter',
		'domain' => 'Domains',
		'referrer' => 'Referrer',
		'start_resource' => 'Startseiten',
		'end_resource' => 'Endseiten',
		'hits' => 'Klicks',
		'prev_resource' => 'Vorherige Seiten',
		'next_resource' => 'Nächste Seiten'
	);
	
	var $labels = array(
		// http://de.wikipedia.org/wiki/ISO-3166-1-Kodierliste
		'country' => array(
			'AD' => 'Andorra',
			'AE' => 'Vereinigte Arabische Emirate',
			'AF' => 'Afghanistan',
			'AG' => 'Antigua and Barbuda',
			'AI' => 'Anguilla',
			'AL' => 'Albanien',
			'AM' => 'Armenien',
			'AN' => 'Niederländische Antillen',
			'AO' => 'Angola',
			'AQ' => 'Antarktis',
			'AR' => 'Argentinien',
			'AS' => 'Amerikanisch-Samoa',
			'AT' => 'Österreich',
			'AU' => 'Australien',
			'AW' => 'Aruba',
			'AX' => 'Åland',
			'AZ' => 'Aserbaidschan',
			'BA' => 'Bosnien und Herzegowina',
			'BB' => 'Barbados',
			'BD' => 'Bangladesch',
			'BE' => 'Belgien',
			'BF' => 'Burkina Faso',
			'BG' => 'Bulgarien',
			'BH' => 'Bahrain',
			'BI' => 'Burundi',
			'BJ' => 'Benin',
			'BL' => 'Saint-Barthélemy',
			'BM' => 'Bermuda',
			'BN' => 'Brunei Darussalam',
			'BO' => 'Bolivien',
			'BR' => 'Brasilien',
			'BS' => 'Bahamas',
			'BT' => 'Bhutan',
			'BV' => 'Bouvetinsel',
			'BW' => 'Botswana',
			'BY' => 'Belarus',
			'BZ' => 'Belize',
			'CA' => 'Kanada',
			'CC' => 'Kokosinseln',
			'CD' => 'Kongo, Demokratische Republik',
			'CE' => 'Europäische Gemeinschaft',
			'CF' => 'Zentralafrikanische Republik',
			'CG' => 'Republik Kongo',
			'CH' => 'Schweiz',
			'CI' => 'Côte d\'Ivoire',
			'CK' => 'Cookinseln',
			'CL' => 'Chile',
			'CM' => 'Kamerun',
			'CN' => 'China, Volksrepublik',
			'CO' => 'Kolumbien',
			'CR' => 'Costa Rica',
			'CU' => 'Kuba',
			'CV' => 'Kap Verde',
			'CX' => 'Weihnachtsinsel',
			'CY' => 'Zypern',
			'CZ' => 'Tschechische Republik',
			'DE' => 'Deutschland',
			'DJ' => 'Dschibuti',
			'DK' => 'Dänemark',
			'DM' => 'Dominica',
			'DO' => 'Dominikanische Republik',
			'DZ' => 'Algerien',
			'EC' => 'Ecuador',
			'EE' => 'Estland',
			'EG' => 'Ägypten',
			'EH' => 'Westsahara',
			'ER' => 'Eritrea',
			'ES' => 'Spanien',
			'ET' => 'Äthiopien',
			'EU' => 'Europäische Union',
			'FI' => 'Finnland',
			'FJ' => 'Fidschi',
			'FK' => 'Falklandinseln',
			'FM' => 'Mikronesien',
			'FO' => 'Färöer',
			'FR' => 'Frankreich',
			'GA' => 'Gabun',
			'GB' => 'Vereinigtes Königreich Großbritannien und Nordirland',
			'GD' => 'Grenada',
			'GE' => 'Georgien',
			'GF' => 'Französisch-Guayana',
			'GG' => 'Guernsey (Kanalinsel)',
			'GH' => 'Ghana',
			'GI' => 'Gibraltar',
			'GL' => 'Grönland',
			'GM' => 'Gambia',
			'GN' => 'Guinea',
			'GP' => 'Guadeloupe',
			'GQ' => 'Äquatorialguinea',
			'GR' => 'Griechenland',
			'GS' => 'Südgeorgien und die Südlichen Sandwichinseln',
			'GT' => 'Guatemala',
			'GU' => 'Guam',
			'GW' => 'Guinea-Bissau',
			'GY' => 'Guyana',
			'HK' => 'Hongkong',
			'HM' => 'Heard und McDonaldinseln',
			'HN' => 'Honduras',
			'HR' => 'Kroatien',
			'HT' => 'Haiti',
			'HU' => 'Hungarn',
			'ID' => 'Indonesien',
			'IE' => 'Irland',
			'IL' => 'Israel',
			'IM' => 'Insel Man',
			'IN' => 'Indien',
			'IO' => 'Britisches Territorium im Indischen Ozean',
			'IQ' => 'Irak',
			'IR' => 'Iran, Islamische Republik',
			'IS' => 'Island',
			'IT' => 'Italien',
			'JE' => 'Jersey',
			'JM' => 'Jamaika',
			'JO' => 'Jordanien',
			'JP' => 'Japan',
			'KE' => 'Kenia',
			'KG' => 'Kirgisistan',
			'KH' => 'Kambodscha',
			'KI' => 'Kiribati',
			'KM' => 'Komoren',
			'KN' => 'St. Kitts und Nevis',
			'KP' => 'Korea, Demokratische Volksrepublik',
			'KR' => 'Korea, Republik',
			'KW' => 'Kuwait',
			'KY' => 'Kaimaninseln',
			'KZ' => 'Kasachstan',
			'LA' => 'Laos, Demokratische Volksrepublik',
			'LB' => 'Libanon',
			'LC' => 'St. Lucia',
			'LI' => 'Liechtenstein',
			'LK' => 'Sri Lanka',
			'LR' => 'Liberia',
			'LS' => 'Lesotho',
			'LT' => 'Litauen',
			'LU' => 'Luxemburg',
			'LV' => 'Lettland',
			'LY' => 'Libysch-Arabische Dschamahirija',
			'MA' => 'Marokko',
			'MC' => 'Monaco',
			'MD' => 'Moldawien',
			'ME' => 'Montenegro',
			'MF' => 'Saint-Martin',
			'MG' => 'Madagaskar',
			'MH' => 'Marshallinseln',
			'MK' => 'Mazedonien, ehem. jugoslawische Republik',
			'ML' => 'Mali',
			'MM' => 'Myanmar',
			'MN' => 'Mongolei',
			'MO' => 'Macao',
			'MP' => 'Nördliche Marianen',
			'MQ' => 'Martinique',
			'MR' => 'Mauretanien',
			'MS' => 'Montserrat',
			'MT' => 'Malta',
			'MU' => 'Mauritius',
			'MV' => 'Malediven',
			'MW' => 'Malawi',
			'MX' => 'Mexiko',
			'MY' => 'Malaysia',
			'MZ' => 'Mosambik',
			'NA' => 'Namibia',
			'NC' => 'Neukaledonien',
			'NE' => 'Niger',
			'NF' => 'Norfolkinsel',
			'NG' => 'Nigeria',
			'NI' => 'Nicaragua',
			'NL' => 'Niederlande',
			'NO' => 'Norwegen',
			'NP' => 'Nepal',
			'NR' => 'Nauru',
			'NU' => 'Niue',
			'NZ' => 'Neuseeland',
			'OM' => 'Oman',
			'PA' => 'Panama',
			'PE' => 'Peru',
			'PF' => 'Französisch-Polynesien',
			'PG' => 'Papua-Neuguinea',
			'PH' => 'Philippinen',
			'PK' => 'Pakistan',
			'PL' => 'Polen',
			'PM' => 'Saint-Pierre und Miquelon',
			'PN' => 'Pitcairninseln',
			'PR' => 'Puerto Rico',
			'PS' => 'Palästinensische Autonomiegebiete',
			'PT' => 'Portugal',
			'PW' => 'Palau',
			'PY' => 'Paraguay',
			'QA' => 'Katar',
			'RE' => 'Réunion',
			'RO' => 'Rumänien',
			'RS' => 'Serbien',
			'RU' => 'Russische Föderation',
			'RW' => 'Ruanda',
			'SA' => 'Saudi-Arabien',
			'SB' => 'Salomonen',
			'SC' => 'Seychellen',
			'SD' => 'Sudan',
			'SE' => 'Schweden',
			'SG' => 'Singapur',
			'SH' => 'St. Helena',
			'SI' => 'Slowenien',
			'SJ' => 'Svalbard und Jan Mayen',
			'SK' => 'Slowakei',
			'SL' => 'Sierra Leone',
			'SM' => 'San Marino',
			'SN' => 'Senegal',
			'SO' => 'Somalia',
			'SR' => 'Suriname',
			'ST' => 'São Tomé und Príncipe',
			'SV' => 'El Salvador',
			'SY' => 'Syrien, Arabische Republik',
			'SZ' => 'Swasiland',
			'TC' => 'Turks- und Caicosinseln',
			'TD' => 'Tschad',
			'TF' => 'Französische Süd- und Antarktisgebiete',
			'TG' => 'Togo',
			'TH' => 'Thailand',
			'TJ' => 'Tadschikistan',
			'TK' => 'Tokelau',
			'TL' => 'Osttimor',
			'TM' => 'Turkmenistan',
			'TN' => 'Tunesien',
			'TO' => 'Tonga',
			'TR' => 'Türkei',
			'TT' => 'Trinidad and Tobago',
			'TV' => 'Tuvalu',
			'TW' => 'Republik China (Taiwan)',
			'TZ' => 'Tansania, Vereinigte Republik',
			'UA' => 'Ukraine',
			'UG' => 'Uganda',
			'UM' => 'United States Minor Outlying Islands',
			'US' => 'Vereinigte Staaten von Amerika',
			'UY' => 'Uruguay',
			'UZ' => 'Usbekistan',
			'VA' => 'Vatikanstadt',
			'VC' => 'St. Vincent und die Grenadinen',
			'VE' => 'Venezuela',
			'VG' => 'Britische Jungferninseln',
			'VI' => 'Amerikanische Jungferninseln',
			'VN' => 'Vietnam',
			'VU' => 'Vanuatu',
			'WF' => 'Wallis und Futuna',
			'WS' => 'Samoa',
			'YE' => 'Yemen',
			'YT' => 'Mayotte',
			'ZA' => 'Südafrika',
			'ZM' => 'Sambia',
			'ZW' => 'Simbabwe'
		),
		// http://www.indexpage.ch/web-worker/know-how/sprachenkuerzel-ISO-639-1.php
		'language' => array(
			'aa' => 'Afar',
			'ab' => 'Abchasisch',
			'ae' => 'Avestan',
			'af' => 'Afrikaans',
			'ak' => 'Akan',
			'am' => 'Amharic',
			'an' => 'Aragonese',
			'ar' => 'Arabisch',
			'as' => 'Assamesisch',
			'av' => 'Avaric',
			'ay' => 'Aymara',
			'az' => 'Aserbaidschanisch',
			'ba' => 'Baschkirisch',
			'be' => 'Belorussisch',
			'bg' => 'Bulgarisch',
			'bh' => 'Biharisch',
			'bi' => 'Bislamisch',
			'bm' => 'Bambara',
			'bn' => 'Bengalisch',
			'bo' => 'Tibetanisch',
			'br' => 'Bretonisch',
			'bs' => 'Bosnisch',
			'ca' => 'Katalanisch',
			'ce' => 'Tschechisch',
			'ch' => 'Chamorro',
			'co' => 'Korsisch',
			'cr' => 'Cree',
			'cs' => 'Tschechisch',
			'cu' => 'Alt-Slavisch',
			'cv' => 'Chuvash',
			'cy' => 'Walisisch',
			'da' => 'Dänisch',
			'de' => 'Deutsch',
			'dv' => 'Divehi',
			'dz' => 'Dzongkha',
			'ee' => 'Ewe',
			'el' => 'Griechisch',
			'en' => 'Englisch',
			'eo' => 'Esperanto',
			'es' => 'Spanisch',
			'et' => 'Estnisch',
			'eu' => 'Baskisch',
			'fa' => 'Persisch',
			'ff' => 'Fulah',
			'fi' => 'Finnisch',
			'fj' => 'Fiji',
			'fo' => 'Faröisch',
			'fr' => 'Französisch',
			'fy' => 'Friesisch',
			'ga' => 'Irisch',
			'gd' => 'Schottisches Gälisch',
			'gl' => 'Galizisch',
			'gn' => 'Guarani',
			'gu' => 'Gujaratisch',
			'gv' => 'Manx',
			'ha' => 'Haussa',
			'he' => 'Hebräisch',
			'hi' => 'Hindi',
			'ho' => 'Hiri Motu',
			'hr' => 'Kroatisch',
			'ht' => 'Haitisch',
			'hu' => 'Hungarisch',
			'hy' => 'Armenisch',
			'hz' => 'Herero',
			'ia' => 'Interlingua',
			'id' => 'Indonesisch',
			'ie' => 'Interlingue',
			'ig' => 'Igbo',
			'ii' => 'Sichuan Yi',
			'ik' => 'Inupiak',
			'io' => 'Ido',
			'is' => 'Isländisch',
			'it' => 'Italienisch',
			'iu' => 'Inuktitut-Eskimo',
			'ja' => 'Japanisch',
			'jv' => 'Javanisch',
			'ka' => 'Georgisch',
			'kg' => 'Kongo',
			'ki' => 'Kikuyu',
			'kj' => 'Kuanyama',
			'kk' => 'Kasachisch',
			'kl' => 'Kalaallisut',
			'km' => 'Kambodschanisch',
			'kn' => 'Kannada',
			'ko' => 'Koreanisch',
			'kr' => 'Kanuri',
			'ks' => 'Kaschmirisch',
			'ku' => 'Kurdisch',
			'kv' => 'Komi',
			'kw' => 'Cornish',
			'ky' => 'Kirgisisch',
			'la' => 'Latinisch',
			'lb' => 'Luxembourgisch',
			'lg' => 'Ganda',
			'li' => 'Limburgisch',
			'ln' => 'Lingala',
			'lo' => 'Laotisch',
			'lt' => 'Litauisch',
			'lu' => 'Luba-Katanga',
			'lv' => 'Lettisch',
			'mg' => 'Malagasisch',
			'mh' => 'Marshallese',
			'mi' => 'Maorisch',
			'mk' => 'Mazedonisch',
			'ml' => 'Malajalam',
			'mn' => 'Mongolisch',
			'mr' => 'Marathi',
			'ms' => 'Malaysisch',
			'mt' => 'Maltesisch',
			'my' => 'Burmesisch',
			'na' => 'Nauruisch',
			'nb' => 'Norwegisch Bokmål',
			'nd' => 'Nord-Ndebele',
			'ne' => 'Nepalisch',
			'ng' => 'Ndonga',
			'nl' => 'Holländisch',
			'nn' => 'Norwegisch Nynorsk',
			'no' => 'Norwegisch',
			'nr' => 'Süd-Ndebele',
			'nv' => 'Navajo',
			'ny' => 'Chichewa',
			'oc' => 'Okzitanisch',
			'oj' => 'Ojibwa',
			'om' => 'Oromo',
			'or' => 'Orija',
			'os' => 'Ossetian',
			'pa' => 'Pundjabisch',
			'pi' => 'Pali',
			'pl' => 'Polnisch',
			'ps' => 'Paschtu',
			'pt' => 'Portugiesisch',
			'qu' => 'Quechua',
			'rm' => 'Rätoromanisch',
			'rn' => 'Rundi',
			'ro' => 'Rumänisch',
			'ru' => 'Russisch',
			'rw' => 'Kijarwanda',
			'sa' => 'Sanskrit',
			'sc' => 'Sardinisch',
			'sd' => 'Zinti',
			'se' => 'Nord-Sami',
			'sg' => 'Sango',
			'si' => 'Singhalesisch',
			'sk' => 'Slowakisch',
			'sl' => 'Slowenisch',
			'sm' => 'Samoanisch',
			'sn' => 'Schonisch',
			'so' => 'Somalisch',
			'sq' => 'Albananisch',
			'sr' => 'Serbisch',
			'ss' => 'Swasiländisch',
			'st' => 'Sesothisch',
			'su' => 'Sudanesisch',
			'sv' => 'Schwedisch',
			'sw' => 'Suaheli',
			'ta' => 'Tamilisch',
			'te' => 'Telugu',
			'tg' => 'Tadschikisch',
			'th' => 'Thai',
			'ti' => 'Tigrinja',
			'tk' => 'Turkmenisch',
			'tl' => 'Tagalog',
			'tn' => 'Sezuan',
			'to' => 'Tongaisch',
			'tr' => 'Türkisch',
			'ts' => 'Tsongaisch',
			'tt' => 'Tatarisch',
			'tw' => 'Twi',
			'ty' => 'Thai',
			'ug' => 'Uighur',
			'uk' => 'Ukrainisch',
			'ur' => 'Urdu',
			'uz' => 'Usbekisch',
			've' => 'Venda',
			'vi' => 'Vietnamesisch',
			'vo' => 'Volapük',
			'wa' => 'Walonisch',
			'wo' => 'Wolof',
			'xh' => 'Xhosa',
			'yi' => 'Jiddisch',
			'yo' => 'Joruba',
			'za' => 'Zhuang',
			'zh' => 'Chinesisch',
			'zh-cn' => 'Chinesisch (Vereinfacht)',
			'zh-tw' => 'Chinesisch (Traditionell)',
			'zu' => 'Zulu'
		),
		'prev_resource' => array( '' => 'Start' ),
		'next_resource' => array( '' => 'End' )
	);
	
	function SlimStatI18n() {
		parent::init();
	}
}
